var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { stringify } from "qs";
import { ref, onMounted as onMounted$1, onBeforeMount as onBeforeMount$1 } from "vue";
import { onBeforeUnmount, onUpdated } from "vue";
import { onLoad as onLoad$1, onShow as onShow$1, onReady as onReady$1, onLaunch } from "@dcloudio/uni-app";
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal || freeSelf || Function("return this")();
var Symbol$1 = root.Symbol;
var objectProto$1 = Object.prototype;
var hasOwnProperty = objectProto$1.hasOwnProperty;
var nativeObjectToString$1 = objectProto$1.toString;
var symToStringTag$1 = Symbol$1 ? Symbol$1.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var objectProto = Object.prototype;
var nativeObjectToString = objectProto.toString;
function objectToString(value) {
  return nativeObjectToString.call(value);
}
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$1 ? Symbol$1.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isArray = Array.isArray;
function isObject(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
function last(array) {
  var length = array == null ? 0 : array.length;
  return length ? array[length - 1] : void 0;
}
var stringTag = "[object String]";
function isString(value) {
  return typeof value == "string" || !isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
}
function normalizingPath(location) {
  const { url, query } = location;
  if (!query) {
    return url;
  }
  const slashPad = url.startsWith("/") ? "" : "/";
  return `${slashPad}${url}?${stringify(query)}`;
}
function hasLocationsRouter(v) {
  return isObject(v) && isString(v.url);
}
const NavigateNames = {
  navigateTo: "navigateTo",
  redirectTo: "redirectTo",
  switchTab: "switchTab",
  reLaunch: "reLaunch"
};
class RouterGuardsEvent {
  constructor() {
    __publicField(this, "event", {
      afterEach: [],
      beforeEach: []
    });
  }
  beforeEach(callback) {
    const index = this.event.beforeEach.push(callback);
    return () => {
      this.event.beforeEach.splice(index, 1);
    };
  }
  afterEach(callback) {
    const index = this.event.afterEach.push(callback);
    return () => {
      this.event.afterEach.splice(index, 1);
    };
  }
}
class RouterGuards extends RouterGuardsEvent {
  constructor() {
    super();
    __publicField(this, "currentRouterPath", ref(null));
    __publicField(this, "pending", ref(false));
    __publicField(this, "isReady", ref(false));
    uni.$RouterGuards = this;
  }
  fixRouterPath(to) {
    if (this.isReady.value) {
      this.currentRouterPath.value = to;
    }
  }
  async navigate(to, navigateName = NavigateNames.navigateTo) {
    try {
      await this.navigateTemp(to, () => {
        return new Promise((r, s) => {
          uni[navigateName]({
            url: normalizingPath(to),
            success: r,
            fail: s
          });
        });
      });
    } finally {
    }
  }
  async navigateTemp(to, callback) {
    const formRouterPath = {
      url: this.currentRouterPath.value
    };
    for (const beforeGuards of this.event.beforeEach) {
      const hasNewRoute = await beforeGuards(formRouterPath, to);
      if (hasNewRoute === false) {
        return;
      }
      if (hasLocationsRouter(hasNewRoute)) {
        await this.navigate(hasNewRoute, hasNewRoute.navigateName);
        return;
      }
    }
    await (callback == null ? void 0 : callback());
    for (const afterGuards of this.event.afterEach) {
      await afterGuards(formRouterPath, to);
    }
  }
  async ready(to) {
    await this.navigateTemp({
      url: to
    });
    this.isReady.value = true;
    this.fixRouterPath(to);
  }
}
function onLoad(callback) {
  onLoad$1(async (v) => {
    await uni.$RouterGuards.withLaunchPromise;
    await callback(v);
  });
}
function onShow(callback) {
  onShow$1(async () => {
    await uni.$RouterGuards.withLaunchPromise;
    await callback();
  });
}
function onReady(callback) {
  onReady$1(async () => {
    await uni.$RouterGuards.withLaunchPromise;
    await callback();
  });
}
function onMounted(callback) {
  onMounted$1(async () => {
    await uni.$RouterGuards.withLaunchPromise;
    await callback();
  });
}
function onBeforeMount(callback) {
  onBeforeMount$1(async () => {
    await uni.$RouterGuards.withLaunchPromise;
    await callback();
  });
}
const EMPTY_OPTIONS = {};
function useGuardsImpl() {
  return uni.$RouterGuards;
}
function useNavigateTo(to, navigateName = NavigateNames.navigateTo) {
  const routerGuards = useGuardsImpl();
  if (routerGuards.pending.value) {
    return;
  }
  if (isString(to)) {
    return routerGuards.navigate(
      {
        url: to
      },
      navigateName
    );
  }
  return routerGuards.navigate(to, navigateName);
}
function useRouter() {
  return {
    route: useRoute(),
    push: (to) => useNavigateTo(to),
    pushTab: (to) => useNavigateTo(to, NavigateNames.switchTab),
    replace: (to) => useNavigateTo(to, NavigateNames.redirectTo),
    replaceAll: (to) => useNavigateTo(to, NavigateNames.reLaunch),
    back: (data = { delta: 1 }) => {
      return new Promise((resolve, reject) => {
        uni.navigateBack({
          success: resolve,
          fail: reject,
          ...data
        });
      });
    }
  };
}
function useRoute() {
  const route = ref({});
  onLoad((options) => {
    const cuPage = last(getCurrentPages());
    useGuardsImpl().fixRouterPath(cuPage.route);
    route.value.url = cuPage.route;
    route.value.query = options ?? EMPTY_OPTIONS;
  });
  return route;
}
function useGuardsReady() {
  return useGuardsImpl().isReady;
}
function onRouterReady(to) {
  let resolve;
  uni.$RouterGuards.withLaunchPromise = new Promise((_resolve) => {
    resolve = _resolve;
  });
  onLaunch(() => {
    useGuardsImpl().ready(to).then(resolve);
  });
}
export {
  NavigateNames,
  RouterGuards,
  RouterGuardsEvent,
  onBeforeMount,
  onBeforeUnmount,
  onLoad,
  onMounted,
  onReady,
  onRouterReady,
  onShow,
  onUpdated,
  useGuardsImpl,
  useGuardsReady,
  useRoute,
  useRouter
};
